package com.glxp.mipsdl.service.hlfyyy;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.glxp.mipsdl.entity.hlfyyy.VA010;
import com.glxp.mipsdl.req.base.UdiwmsBasicSkPrescribeRequest;
import com.glxp.mipsdl.thirddao.hlfyyy.VA011Mapper;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.glxp.mipsdl.entity.hlfyyy.VA011;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

@Service
public class VA011Service extends ServiceImpl<VA011Mapper, VA011> {
    @Resource
    private VA011Mapper va011Mapper;
    @Value("${DSF_XML_SQL_TYPE:MySql}")
    private String defXmlSqlType;
    public IPage<VA011> getList(Page page , UdiwmsBasicSkPrescribeRequest udiwmsBasicSkPrescribeRequest){
        IPage<VA011> iPage = va011Mapper.getList(page,udiwmsBasicSkPrescribeRequest);
        List<VA011> list  =  iPage.getRecords();
        List<VA011> listNew  = new ArrayList<>();
        if(list!=null && list.size() >0){
            String lastSql = "";
            if(defXmlSqlType.equals("MySql")){
                lastSql = " limit  1";

            }else if(defXmlSqlType.equals("Oracle")){
                lastSql = "AND rownum = 1";
            }
            for (VA011 va011 : list) {


                VA011 va011New  = va011Mapper.selectOne(new QueryWrapper<VA011>().eq("code",va011.getCode()).last(lastSql));
                listNew.add(va011New);
            }
        }
        listNew.sort( Comparator.comparing(VA011::getPrescribedate));
        iPage.setRecords(listNew);

        return iPage;
    };
}
