package com.glxp.mipsdl.entity.hlfyyy;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 医疗器械产品信息查询
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "v_a002")
public class VA002 implements Serializable {
    @TableField(value = "LASTUPDATETIME")
    private String lastupdatetime;

    @TableField(value = "CODE")
    private String code;

    @TableField(value = "NAME")
    private String name;

    @TableField(value = "MEASNAME")
    private String measname;

    @TableField(value = "STANDARD")
    private String standard;

    @TableField(value = "REGISTERNO")
    private String registerno;

    @TableField(value = "MANUFACTORYCODE")
    private String manufactorycode;

    @TableField(value = "MANUFACTORY")
    private String manufactory;

    @TableField(value = "SUPCODE")
    private String supcode;

    @TableField(value = "SUPNAME")
    private String supname;

    @TableField(value = "CPLB")
    private String cplb;

    @TableField(value = "FLBM")
    private String flbm;

    @TableField(value = "QXLB")
    private String qxlb;

    @TableField(value = "YBBM")
    private String ybbm;

    @TableField(value = "SPTM")
    private String sptm;

    @TableField(value = "TYSHXYDM")
    private String tyshxydm;

    @TableField(value = "YLQXZCRBARMC")
    private String ylqxzcrbarmc;

    @TableField(value = "YLQXZCRBARYWMC")
    private String ylqxzcrbarywmc;

    @TableField(value = "CPMS")
    private String cpms;

    @TableField(value = "SPMC")
    private String spmc;

    @TableField(value = "QTBM")
    private String qtbm;

    @TableField(value = "ZCZYXQZ")
    private String zczyxqz;

    @TableField(value = "PRICE")
    private String price;

    @TableField(value = "RETAILPRICE")
    private String retailprice;

    @TableField(value = "INVCODE")
    private String invcode;

    @TableField(value = "REMARK")
    private String remark;

    @TableField(value = "REMARK1")
    private String remark1;

    @TableField(value = "REMARK2")
    private String remark2;

    @TableField(value = "REMARK3")
    private String remark3;

    @TableField(value = "REMARK4")
    private String remark4;

    @TableField(value = "REMARK5")
    private String remark5;

    private static final long serialVersionUID = 1L;
}
