package com.glxp.mipsdl.service.hlfyyy;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.glxp.mipsdl.req.base.UdiwmsBasicSkPrescribeRequest;
import com.glxp.mipsdl.thirddao.hlfyyy.VA010Mapper;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.glxp.mipsdl.entity.hlfyyy.VA010;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

@Service
public class VA010Service extends ServiceImpl<VA010Mapper, VA010> {
    @Resource
    private VA010Mapper va010Mapper;
    @Value("${DSF_XML_SQL_TYPE:MySql}")
    private String defXmlSqlType;
    public IPage<VA010> getList(Page page , UdiwmsBasicSkPrescribeRequest udiwmsBasicSkPrescribeRequest){
        IPage<VA010> iPage = va010Mapper.getList(page,udiwmsBasicSkPrescribeRequest);
        List<VA010> list  =  iPage.getRecords();
        List<VA010> listNew  = new ArrayList<>();
        if(list!=null && list.size() >0){
            String lastSql = "";
            if(defXmlSqlType.equals("MySql")){
                lastSql = " limit  1";

            }else if(defXmlSqlType.equals("Oracle")){
                lastSql = "AND rownum = 1";
            }
            for (VA010 va010 : list) {


                VA010 va010New  = va010Mapper.selectOne(new QueryWrapper<VA010>().eq("code",va010.getCode()).last(lastSql));
                listNew.add(va010New);
            }
        }
        listNew.sort( Comparator.comparing(VA010::getPrescribedate));

        iPage.setRecords(listNew);

        return iPage;
    }

}
